Subject: bug#11860: 24.1; Arabic - Harakat (diacritics, short vowels) don't appear

From: Steffan <[email-masked]>
Date: Mon, 03 Sep 2012 17:31:39 +0200

>> From: Kenichi Handa <[email-masked]>
>> Cc: [email-masked],[email-masked],[email-masked],[email-masked]
>> Date: Wed, 29 Aug 2012 17:09:49 +0900
>>
>> In article <[email-masked]>, Steffan <[email-masked]> writes:
>>
>>> I've just tested it. It's different. But it doesn't work correctly.
>>> In the arabic-input-method
>>> h-X-SPACE-h works fine,
>>> but h-X-h doesn't work, the Sukkun disappears.
>>
>> I also tested with the following windows binary
>> (emacs-trunk-r109787-bin-w32-i386.zip) and confirmed the problem:
>>
>> In article <CAH8Pv0g81jwWvQJ1xjmnU=[email-masked]>, Dani Moncayo <[email-masked]> writes:
>>
>>> I've just uploaded a w32 binary (from today's trunk):
>>> https://www.dropbox.com/sh/7jr3vbv9tm1zod0/jPuvfrJAe8
>>
>> I evaluated the attached funcion in *scratch* buffer and it
>> returned this string on Windows.
>>
>> " [0 1 1575 909 18 7 10 25 8 nil]
>> [0 1 1575 760 0 7 11 25 8 [-1 1 0]]
>>
>> [0 1 1575 909 18 7 10 25 8 nil]
>> [0 1 1575 760 0 7 11 25 8 [-19 1 0]]
>>
>> "
>>
>> The second GLYPHs in the first and second GSTRINGs are
>> different. On GNU/Linux, they are the same, which should be
>> the correct behaviour.
> 
> The problem was that the code I committed didn't expect to handle more
> than a single grapheme cluster. I now fixed that code for the case of
> several grapheme clusters that are handed to the shaper all at once.
> With the modified code (trunk revision 109842), both Steffan's recipe
> and the check-arabic-shaper function work correctly. Please test.
> 
> Thanks.

 -- 

Thanks, this bug is now fixed. But there is something wrong with the two diacritics (short vowels): ARABIC KASRA and ARABIC KASRATAN. They should appear UNDER the letters, not IN or OVER them.

Try a-A [Sheen-Kasra] or a-S [Sheen-Kasratan] or d-S [Ya-Kasratan]. 
But h-S or m-S has the correct form. (?)

I tested this trunk:
 emacs-20120903-r109861-bin-i386.zip         03-Sep-2012 03:07   58M  

The arabic letters don't have a constant form. This seems to be the problem (?): Try f-S and compare with f-S-f.